using System;
using UnityEngine;

namespace Mod
{
    public class Bpower : MonoBehaviour
    {
        private Vector2 barrelPosition = new Vector2(0f, -0.275f);
        private Vector2 barrelDirection = Vector2.down;

        private LayerMask layers;
        private LayerMask bounds;

        RaycastHit2D ray;
        AudioSource audio;
        public float power = 3000f;

        LineRenderer line;
        public void Awake()
        {
            layers = LayerMask.GetMask("Objects", "CollidingDebris", "Bounds");
            bounds = LayerMask.GetMask("Bounds");

            line = gameObject.AddComponent<LineRenderer>();
            line.material = ModAPI.FindMaterial("VeryBright");
            line.numCapVertices = 1;
            line.startColor = new Color(0f, 0f, 0f, 0f);
            line.endColor = new Color(0f, 0f, 0f, 0f);
            line.startWidth = 0.20f;
            line.endWidth = 0.20f;
            line.rendererPriority = 5;
        }

        public void Shoot()
        {
            line.startColor = new Color(0f, 1f, 0f, 1f);
            line.endColor = new Color(0f, 1f, 0f, 1f);
            line.startWidth = 0.30f;
            line.endWidth = 0.30f;

            if (ray.collider.gameObject.layer == 9)
            {
                var end = Physics2D.Raycast(BarrelPosition, BarrelDirection, 0, bounds);
                var endPos = end.transform == null ? (Vector2)BarrelPosition + (Vector2)BarrelDirection * 1 : (Vector2)ray.point;
                 ExplosionCreator.CreatePulseExplosion(ray.point, 3f, 3, true);
                 ray.transform.SendMessage("Slice", SendMessageOptions.DontRequireReceiver);
                 ray.transform.SendMessage("Break", SendMessageOptions.DontRequireReceiver);

            }
        }

        void Update()
        {
            ray = Physics2D.Raycast(BarrelPosition, BarrelDirection, Mathf.Infinity);
            line.SetPosition(0, BarrelPosition);
            line.SetPosition(1, ray.point);
            line.startWidth = Mathf.MoveTowards(line.startWidth, 0f, Time.deltaTime);
            line.endWidth = Mathf.MoveTowards(line.endWidth, 0f, Time.deltaTime);
        }

        void UseContinuous()
        {
            Shoot();
        }

        public  Vector2 BarrelPosition { get { return transform.TransformPoint(barrelPosition); } }
        public Vector2 BarrelDirection { get { return transform.TransformDirection(barrelDirection) * transform.localScale.x; } }
    }
}
// Originally uploaded by 'Kaioh'. Do not reupload without their explicit permission.
