﻿using UnityEngine;

namespace Mod
{
    public class Hornetpower : MonoBehaviour
    {

        private GameObject hand;

        private GameObject handGlow;

        public void Awake()
        {
            hand = gameObject;

            handGlow = new GameObject();
            handGlow.transform.parent = hand.transform;
            handGlow.transform.localPosition = new Vector3(0f, 0f);
            handGlow.transform.localScale = gameObject.transform.parent.localScale;

            var handSprite = handGlow.AddComponent<SpriteRenderer>();

            handSprite.sprite = ModAPI.LoadSprite("");
            handSprite.material = ModAPI.FindMaterial("VeryBright");

            handSprite.sortingLayerName = "Top";
        }

        public void OnCollisionEnter2D(Collision2D other)
        {
            var rb = hand.GetComponent<Rigidbody2D>();

            {
              other.gameObject.GetComponent<LimbBehaviour>().SkinMaterialHandler.ShotDamage(100f, transform.position, true);
              other.gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.AddLiquid(Liquid.GetLiquid("GORSE BLOOD"), 50);


            }

        }

        public void FixedUpdate()
        {
            if(hand.GetComponent<Rigidbody2D>().velocity.magnitude >= 5f)
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 0f, 0f, Mathf.Clamp(gameObject.GetComponent<Rigidbody2D>().velocity.magnitude / 250f, 0f, 1f));
            }
            else
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 0f, 0f, 1f);
            }
        }
    }
}

// Originally uploaded by 'Kaioh'. Do not reupload without their explicit permission.
