using UnityEngine;

namespace Mod
{
    public class MBP : MonoBehaviour
    {

      public bool Activated = false;
      bool IsUsable = true;

        private GameObject hand;

        private GameObject handGlow;

        public void Start()
        {
            hand = gameObject;

            handGlow = new GameObject();
            handGlow.transform.parent = hand.transform;
            handGlow.transform.localPosition = new Vector3(0f, 0f);
            handGlow.transform.localScale = gameObject.transform.parent.localScale;

            var handSprite = handGlow.AddComponent<SpriteRenderer>();

            handSprite.sprite = ModAPI.LoadSprite("");
            handSprite.material = ModAPI.FindMaterial("Sprites-Default");
            handSprite.color = new Color(0f, 0f, 0f, 0f);
            handSprite.sortingLayerName = "Top";
        }

        public void OnCollisionEnter2D(Collision2D other)
        {
            var rb = hand.GetComponent<Rigidbody2D>();
  if (Activated)
            {
                other.gameObject.GetComponent<Rigidbody2D>().velocity = rb.velocity * 1;
                var effect = ModAPI.CreateParticleEffect("Flash", new Vector2(gameObject.transform.position.x, gameObject.transform.position.y));
                var main = effect.GetComponent<ParticleSystem>().main;main.startColor = new Color(255/255f, 0/255f, 0/255f);
                var effect1 = ModAPI.CreateParticleEffect("Flash", new Vector2(gameObject.transform.position.x, gameObject.transform.position.y));
                var main1 = effect1.GetComponent<ParticleSystem>().main;main1.startColor = new Color(139/255f, 0/255f, 0/255f);
                other.gameObject.GetComponent<PhysicalBehaviour>().SendMessage("OnEMPHit", SendMessageOptions.DontRequireReceiver);
                other.gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.AddLiquid(Liquid.GetLiquid("REANIMATION AGENT"), 1000f);
            }

        }

        public void FixedUpdate()
        {
            if(hand.GetComponent<Rigidbody2D>().velocity.magnitude >= 3f)
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 0f, 0f, Mathf.Clamp(gameObject.GetComponent<Rigidbody2D>().velocity.magnitude / 1f, 1f, 1f));
            }
            else
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 0f, 0f, 0f);
            }
        }

        private void Use()
        {
            SetActivated(!Activated);
        }

        private void SetActivated(bool a)
        {
        Activated = a;
         }

    }
}

// Originally uploaded by 'Kaioh'. Do not reupload without their explicit permission.
